//
//  jpHenkan.m
//  GestureTest
//
//

#import "jpHenkan.h"


@implementation jpHenkan
-(jpHenkan*)initDic
{
	//辞書データを読む
	dict = [[NSMutableArray alloc]init];
	
	//NSString*dictData_path = @"JPDIC.dat";
	
	NSString *dictData_path = @"/Library/iKeyEx/Keyboards/Gesture.keyboard/JPDIC.dat";
	
	NSError *error;	
	NSString * filename  = [NSHomeDirectory() stringByAppendingPathComponent:dictData_path];
	//NSString * dictFile = [NSString stringWithContentsOfFile:
	///							[[[NSBundle mainBundle] resourcePath]
	//			stringByAppendingPathComponent:dictData_path] encoding:NSUTF8StringEncoding error:&error];

	NSString * dictFile = [NSString stringWithContentsOfFile:dictData_path encoding:NSUTF8StringEncoding error:&error];

	
	NSArray  *lines;
	lines = [dictFile componentsSeparatedByString:@"\r"];
	
	int nDictCount = 0;
	while([lines count] > nDictCount)
	{			
		NSArray* tempDictInfo = [[lines objectAtIndex:nDictCount] componentsSeparatedByString:@"\t"];
		if([tempDictInfo count]==2)
		{
			[dict addObject:[[dicData alloc]initWithValue:
						[tempDictInfo objectAtIndex:0] henkan:[tempDictInfo objectAtIndex:1]]];
		}
		nDictCount++;
	}
	
	pobox_cands = [[NSMutableArray alloc]init];
	
	return self;
}

-(void)clearCandidate
{
	[pobox_cands removeAllObjects];

}
-(void)setCandidate:(NSString*)in_yomi
{
	//辞書検索
	[pobox_cands removeAllObjects];
	
	for(int i=0;i<[dict count]&&[pobox_cands count] < 10;i++)
	{
		dicData *checkTango = (dicData*)[dict objectAtIndex:i];
					
			
		NSString *yomi = checkTango.yomi;
		NSString *henkan = checkTango.henkan;
		if(YES == [yomi hasPrefix:in_yomi])
		{
			[pobox_cands addObject:henkan];
		}
	}
	
	return;
}


-(NSArray*)getCandidate
{
 	return pobox_cands;
}


-(void)dealloc
{
	
	[pobox_cands removeAllObjects];
	[pobox_cands release];
	[dict removeAllObjects];
	[dict release];
	[super dealloc];
}

@end

@implementation dicData
@synthesize yomi,henkan;

-(dicData*)initWithValue:(NSString*)in_yomi henkan:(NSString*)in_henkan 
{
	yomi = [[NSString alloc]initWithString:in_yomi];
	henkan = [[NSString alloc]initWithString:in_henkan];
	return self;
}

-(void)dealloc
{
	[yomi release];
	[henkan release];
	[super dealloc];
}




@end
